/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-18 at 06:20:14 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.cloudresourcemanager.model;

/**
 * A Folder in an Organization's resource hierarchy, used to organize that Organization's resources.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud Resource Manager API. For a detailed
 * explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Folder extends com.google.api.client.json.GenericJson {

  /**
   * Output only. Timestamp when the Folder was created. Assigned by the server.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String createTime;

  /**
   * The folder’s display name. A folder’s display name must be unique amongst its siblings, e.g. no
   * two folders with the same parent can share the same display name. The display name must start
   * and end with a letter or digit, may contain letters, digits, spaces, hyphens and underscores
   * and can be no longer than 30 characters. This is captured by the regular expression:
   * [\p{L}\p{N}]([\p{L}\p{N}_- ]{0,28}[\p{L}\p{N}])?.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String displayName;

  /**
   * Output only. The lifecycle state of the folder. Updates to the lifecycle_state must be
   * performed via DeleteFolder and UndeleteFolder.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String lifecycleState;

  /**
   * Output only. The resource name of the Folder. Its format is `folders/{folder_id}`, for example:
   * "folders/1234".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Required. The Folder’s parent's resource name. Updates to the folder's parent must be performed
   * via MoveFolder.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String parent;

  /**
   * Output only. Timestamp when the Folder was created. Assigned by the server.
   * @return value or {@code null} for none
   */
  public String getCreateTime() {
    return createTime;
  }

  /**
   * Output only. Timestamp when the Folder was created. Assigned by the server.
   * @param createTime createTime or {@code null} for none
   */
  public Folder setCreateTime(String createTime) {
    this.createTime = createTime;
    return this;
  }

  /**
   * The folder’s display name. A folder’s display name must be unique amongst its siblings, e.g. no
   * two folders with the same parent can share the same display name. The display name must start
   * and end with a letter or digit, may contain letters, digits, spaces, hyphens and underscores
   * and can be no longer than 30 characters. This is captured by the regular expression:
   * [\p{L}\p{N}]([\p{L}\p{N}_- ]{0,28}[\p{L}\p{N}])?.
   * @return value or {@code null} for none
   */
  public java.lang.String getDisplayName() {
    return displayName;
  }

  /**
   * The folder’s display name. A folder’s display name must be unique amongst its siblings, e.g. no
   * two folders with the same parent can share the same display name. The display name must start
   * and end with a letter or digit, may contain letters, digits, spaces, hyphens and underscores
   * and can be no longer than 30 characters. This is captured by the regular expression:
   * [\p{L}\p{N}]([\p{L}\p{N}_- ]{0,28}[\p{L}\p{N}])?.
   * @param displayName displayName or {@code null} for none
   */
  public Folder setDisplayName(java.lang.String displayName) {
    this.displayName = displayName;
    return this;
  }

  /**
   * Output only. The lifecycle state of the folder. Updates to the lifecycle_state must be
   * performed via DeleteFolder and UndeleteFolder.
   * @return value or {@code null} for none
   */
  public java.lang.String getLifecycleState() {
    return lifecycleState;
  }

  /**
   * Output only. The lifecycle state of the folder. Updates to the lifecycle_state must be
   * performed via DeleteFolder and UndeleteFolder.
   * @param lifecycleState lifecycleState or {@code null} for none
   */
  public Folder setLifecycleState(java.lang.String lifecycleState) {
    this.lifecycleState = lifecycleState;
    return this;
  }

  /**
   * Output only. The resource name of the Folder. Its format is `folders/{folder_id}`, for example:
   * "folders/1234".
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Output only. The resource name of the Folder. Its format is `folders/{folder_id}`, for example:
   * "folders/1234".
   * @param name name or {@code null} for none
   */
  public Folder setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * Required. The Folder’s parent's resource name. Updates to the folder's parent must be performed
   * via MoveFolder.
   * @return value or {@code null} for none
   */
  public java.lang.String getParent() {
    return parent;
  }

  /**
   * Required. The Folder’s parent's resource name. Updates to the folder's parent must be performed
   * via MoveFolder.
   * @param parent parent or {@code null} for none
   */
  public Folder setParent(java.lang.String parent) {
    this.parent = parent;
    return this;
  }

  @Override
  public Folder set(String fieldName, Object value) {
    return (Folder) super.set(fieldName, value);
  }

  @Override
  public Folder clone() {
    return (Folder) super.clone();
  }

}
