/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-18 at 06:20:14 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.cloudresourcemanager.model;

/**
 * The MoveFolder request message.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud Resource Manager API. For a detailed
 * explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class MoveFolderRequest extends com.google.api.client.json.GenericJson {

  /**
   * Required. The resource name of the Folder or Organization to reparent the folder under. Must be
   * of the form `folders/{folder_id}` or `organizations/{org_id}`.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String destinationParent;

  /**
   * Required. The resource name of the Folder or Organization to reparent the folder under. Must be
   * of the form `folders/{folder_id}` or `organizations/{org_id}`.
   * @return value or {@code null} for none
   */
  public java.lang.String getDestinationParent() {
    return destinationParent;
  }

  /**
   * Required. The resource name of the Folder or Organization to reparent the folder under. Must be
   * of the form `folders/{folder_id}` or `organizations/{org_id}`.
   * @param destinationParent destinationParent or {@code null} for none
   */
  public MoveFolderRequest setDestinationParent(java.lang.String destinationParent) {
    this.destinationParent = destinationParent;
    return this;
  }

  @Override
  public MoveFolderRequest set(String fieldName, Object value) {
    return (MoveFolderRequest) super.set(fieldName, value);
  }

  @Override
  public MoveFolderRequest clone() {
    return (MoveFolderRequest) super.clone();
  }

}
