/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-18 at 06:20:14 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.cloudresourcemanager.model;

/**
 * The response message for searching folders.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Cloud Resource Manager API. For a detailed
 * explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class SearchFoldersResponse extends com.google.api.client.json.GenericJson {

  /**
   * A possibly paginated folder search results. the specified parent resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Folder> folders;

  /**
   * A pagination token returned from a previous call to `SearchFolders` that indicates from where
   * searching should continue.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextPageToken;

  /**
   * A possibly paginated folder search results. the specified parent resource.
   * @return value or {@code null} for none
   */
  public java.util.List<Folder> getFolders() {
    return folders;
  }

  /**
   * A possibly paginated folder search results. the specified parent resource.
   * @param folders folders or {@code null} for none
   */
  public SearchFoldersResponse setFolders(java.util.List<Folder> folders) {
    this.folders = folders;
    return this;
  }

  /**
   * A pagination token returned from a previous call to `SearchFolders` that indicates from where
   * searching should continue.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * A pagination token returned from a previous call to `SearchFolders` that indicates from where
   * searching should continue.
   * @param nextPageToken nextPageToken or {@code null} for none
   */
  public SearchFoldersResponse setNextPageToken(java.lang.String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  @Override
  public SearchFoldersResponse set(String fieldName, Object value) {
    return (SearchFoldersResponse) super.set(fieldName, value);
  }

  @Override
  public SearchFoldersResponse clone() {
    return (SearchFoldersResponse) super.clone();
  }

}
